%ifarch ppc ppc64
%define __arch ppc
%else
%ifarch arm64
%define __arch arm64
%else
%define __arch x86_64
%endif
%endif
%define __pythiaver 6.428
%define __gslver 1.16

Summary: ROOT5
Name: root5
Version: 5.34.36
Release: 13%{?dist}6a
Source0: localhost:/root_v%{version}.source.tar.gz
Patch0:  localhost:/root_v5.28.00-macosx10.6.patch
Patch1:  localhost:/root_v5.34.36-macosx10.12.patch
Patch2:  localhost:/root_v5.34.36-gcc6.patch
Patch3:  localhost:/root_v5.34.36-gcc7.patch
Patch4:  localhost:/root_v5.34.36-gcc9.patch
Patch5:  localhost:/root_v5.34.36-x11location.patch
Patch6:  localhost:/gcc9_stl_iterator.patch
Patch7:  localhost:/root_v5.34.36-macosx10.15.patch
Patch8:  localhost:/root_v5.34.36-macos12.patch
Patch9:  localhost:/root_v5.34.36-cxx17.patch
Patch10:  localhost:/root_v5.34.36-macos12-opengl.patch
Patch11:  localhost:/root_v5.34.36-macos12-dlookup.patch
Patch12:  localhost:/gcc11_stl_iterator.patch
Patch13:  localhost:/root_v5.34.36-gcc11.patch
Patch14:  localhost:/root_v5.34.36-macos12-vaargs.patch
Patch15:  localhost:/root_v5.34.36-macos12-novaargs.patch
Patch16:  localhost:/root_v5.34.36-macos13.patch
Patch17:  localhost:/root_v5.34.36-gcc13.patch
URL: http://wwwasd.web.cern.ch/wwwasd/cernlib/
Group: Development/Libraries
License: LGPL
%define __prefix	/opt/root
Prefix: %{__prefix}
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: pythia = %{__pythiaver}
BuildRequires: fftw3-devel gsl1-devel
Requires: pythia
Requires: gsl1 = %{__gslver}
Obsoletes: root < 6.0

Provides: climits.dll
Provides: complex.dll
Provides: deque.dll
Provides: exception.dll
Provides: ipc.dll
Provides: list.dll
Provides: map.dll
Provides: map2.dll
Provides: multimap.dll
Provides: multimap2.dll
Provides: multiset.dll
Provides: posix.dll
Provides: queue.dll
Provides: set.dll
Provides: stack.dll
Provides: stdcxxfunc.dll
Provides: stdexcept.dll
Provides: stdfunc.dll
Provides: valarray.dll
Provides: vector.dll
Provides: vectorbool.dll

%description
The ROOT system provides a set of OO frameworks with all the functionality needed to handle
and analyse large amounts of data in a very efficient way. Having the data defined as a set 
of objects, specialised storage methods are used to get direct access to the separate 
attributes of the selected objects, without having to touch the bulk of the data. Included 
are histograming methods in 1, 2 and 3 dimensions, curve fitting, function evaluation, 
minimisation, graphics and visualization classes to allow the easy setup of an analysis 
system that can query and process the data interactively or in batch mode.

Thanks to the builtin CINT C++ interpreter the command language, the scripting, or macro, 
language and the programming language are all C++. The interpreter allows for fast prototyping 
of the macros since it removes the time consuming compile/link cycle. It also provides a good 
environment to learn C++. If more performance is needed the interactively developed macros 
can be compiled using a C++ compiler.

The system has been designed in such a way that it can query its databases in parallel on MPP 
machines or on clusters of workstations or high-end PC's. ROOT is an open system that can be 
dynamically extended by linking external libraries. This makes ROOT a premier platform on 
which to build data acquisition, simulation and data analysis systems.

%prep
%setup -n root -q
%patch0 -p1 -b .osx
%patch1 -p1 -b .osx
if [ `g++ --version | grep 'g++' | sed -e 's;g++ (GCC) \([0-9]\).[0-9].[0-9];\1;'` -lt 7 ]; then
%patch2 -p1 -b .gcc6
fi
if [ `g++ --version | grep 'g++' | sed -e 's;g++ (GCC) \([0-9]\).[0-9].[0-9];\1;'` -eq 7 ]; then
%patch3 -p1 -b .gcc7
fi
if [ `g++ --version | grep 'g++' | sed -e 's;g++ (GCC) \([0-9]\{1,\}\).[0-9].[0-9];\1;'` -ge 9 ]; then
%patch4 -p1 -b .gcc9
%patch6 -p1 -b .gcc9-2
fi
%patch5 -p1 -b .x11
%patch7 -p1 -b .osx15
%patch8 -p1 -b .macos12
%patch9 -p1 -b .cxx17
%patch10 -p1 -b .macos12-opengl
%patch11 -p1 -b .macos12-dlookup
%patch12 -p1 -b .gcc11
%patch13 -p1 -b .gcc11-2
%patch14 -p1 -b .macos12-vaargs
#%patch15 -p1 -b .macos12-novaargs
%patch16 -p1 -b .macos13
%patch17 -p1 -b .gcc13

rm -rf $RPM_BUILD_ROOT

%build
# x11 w/ python:
./configure macosx64 --build=debug --with-cc='gcc' --with-cxx='g++' --with-f77=gfortran --with-ld=g++ --with-pythia6-libdir=/opt/pythia/v%{__pythiaver}/lib --enable-minuit2 --enable-roofit --enable-gdml --enable-mathmore --enable-gsl-shared --with-finkdir=/opt/osxws --disable-cocoa --disable-bonjour --with-gsl-incdir=/opt/gsl/%{__gslver}/include --with-gsl-libdir=/opt/gsl/%{__gslver}/lib --with-python-incdir=/opt/osxws/include/python2.7 --with-python-libdir=/opt/osxws/lib #--with-x11-libdir=/opt/X11/lib
# x11 w/o python:
#./configure macosx64 --build=debug --with-cc='gcc' --with-cxx='g++' --with-f77=gfortran --with-ld=g++ --with-pythia6-libdir=/opt/pythia/v%{__pythiaver}/lib --enable-minuit2 --enable-roofit --enable-gdml --enable-mathmore --enable-gsl-shared --with-finkdir=/opt/osxws --disable-cocoa --disable-bonjour --with-gsl-incdir=/opt/gsl/%{__gslver}/include --with-gsl-libdir=/opt/gsl/%{__gslver}/lib --disable-python #--with-x11-libdir=/opt/X11/lib
# cocoa w/o python and w/ clang:
#./configure macosx64 --build=debug --with-cc='clang' --with-cxx='clang++' --with-ld='clang++' --with-pythia6-libdir=/opt/pythia/v%{__pythiaver}/lib --enable-minuit2 --enable-roofit --enable-gdml --enable-mathmore --enable-gsl-shared --with-finkdir=/opt/osxws --enable-cocoa --disable-bonjour --disable-x11 --with-gsl-incdir=/opt/gsl/%{__gslver}/include --with-gsl-libdir=/opt/gsl/%{__gslver}/lib --with-ssl-incdir=/opt/osxws/include --with-ssl-libdir=/opt/osxws/lib --disable-python #--with-x11-libdir=/opt/X11/lib
(cd $RPM_BUILD_DIR/root/graf3d/ftgl/inc
mv FTGlyph.h RFTGlyph.h
cd ../src
mkdir tmp
mv *.cxx tmp
cd tmp
for i in *; do
sed -e 's;FTGlyph\.h;RFTGlyph.h;' $i > ../$i
done
cd ../../inc
mkdir tmp
mv *.h tmp
cd tmp
for i in *; do
sed -e 's;FTGlyph\.h;RFTGlyph.h;' $i > ../$i
done
)
make %{?_smp_mflags} # EXTRA_LDFLAGS='-L/opt/osxws/lib -lquadmath'

%install
mkdir -p $RPM_BUILD_ROOT%{__prefix}
export DYLD_LIBRARY_PATH=/opt/osxws/lib:`xcrun --show-sdk-path`/usr/lib
export ROOTSYS=%{__prefix}/%{version}
make install DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,wheel)
%dir %{__prefix}/%{version}
%{__prefix}/%{version}/*

%changelog
* Fri Nov 3 2023 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-13hepx6a
- 1st release on MacOS 13.
- added macos13 and gcc13 patches.
- use gcc13.
- built with OSXWS 13 and with private python2.7.

* Sun Feb 27 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx5k
- 15th release on MacOS 12 for M1 Macs.
- added macos12, cxx17, gcc11, macos12-gcc11, dlookup, opengl, and macos12-vaargs patches.
- modified macos12 to patch RConfig.h for arm64 (byteswap) and libcompat test.
- use gcc11.
- built with OSXWS 12beta and with private python2.7

* Sat Feb 19 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx5j
- 14th release on MacOS 12 for M1 Macs.
- added macos12, cxx17, gcc11, macos12-gcc11, dlookup, opengl, and macos12-vaargs patches.
- modified macos12 to patch RConfig.h for arm64 (byteswap) and libcompat test.
- use gcc11.
- built with OSXWS 11 and with private python2.7

* Fri Feb 18 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx5i
- 13th release on MacOS 12 for M1 Macs.
- added macos12, cxx17, gcc11, macos12-gcc11, dlookup, opengl, and macos12-vaargs patches.
- modified macos12 to patch RConfig.h for arm64 (byteswap).
- added macos12-novaargs patch to switch of varargs support.
- use gcc11.
- built with OSXWS 11 and with private python2.7

* Fri Feb 18 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx5h
- 12th release on MacOS 12 for M1 Macs.
- added macos12, cxx17, gcc11, macos12-gcc11, dlookup, opengl, and macos12-vaargs patches.
- modified macos12 to patch RConfig.h for arm64 (byteswap).
- modified macos12-vaargs patch.
- use gcc11
- built with OSXWS 11 and with private python2.7

* Wed Feb 16 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx5g
- 11th release on MacOS 12 for M1 Macs.
- renewed macos12 patch.
- added macos12, cxx17, gcc11, macos12-gcc11, dlookup, opengl, and macos12-vaargs patches.
- modified macos12 to patch RConfig.h for arm64 (byteswap).
- use gcc11
- built with OSXWS 11 and with private python2.7

* Wed Feb 16 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx5f
- 10th release on MacOS 12 for M1 Macs.
- renewed macos12 patch.
- added macos12, cxx17, gcc11, macos12-gcc11, dlookup, opengl, and macos12-vaargs patches.
- modified macos12 to patch RConfig.h for arm64 (byteswap).
- use gcc11
- built with OSXWS 11 and without python

* Wed Feb 16 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx5e
- 9th release on MacOS 12 for M1 Macs.
- renewed macos12 patch.
- added macos12, cxx17, gcc11, macos12-gcc11, dlookup, and opengl patches.
- modified macos12 to patch RConfig.h for arm64 (byteswap).
- use gcc11
- built with OSXWS 11 and without python

* Wed Feb 16 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx5d
- 8th release on MacOS 12 for M1 Macs.
- renewed macos12 patch.
- added macos12, cxx17, gcc11, macos12-gcc11, dlookup, and opengl patches.
- modified macos12 to patch RConfig.h for arm64 (byteswap).
- use cocoa and clang++ 
- built with OSXWS 11 and without python

* Tue Feb 15 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx5c
- 7th release on MacOS 12 for M1 Macs.
- added macos12, cxx17, gcc11, macos12-gcc11, dlookup, opengl, and reentrant patches.
- use cocoa and clang++ 
- built with OSXWS 11 and without python

* Mon Feb 14 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx5b
- 6th release on MacOS 12 for M1 Macs.
- added macos12, cxx17, gcc11, macos12-gcc11, dlookup, and opengl patches.
- use cocoa and clang++
- built with OSXWS 11 and without python

* Mon Feb 14 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx5a
- 5th release on MacOS 12 for M1 Macs.
- added macos12, cxx17, gcc11, macos12-gcc11, dlookup, and opengl patches.
- use x11 and g++
- built with OSXWS 11 and without python

* Sun Feb 13 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx4a
- 4th release on MacOS 12 for M1 Macs.
- added macos12, macos12-cint, cxx17, macos12-cintdll, and opengl patches.
- use cocoa instead of x11 and clang
- built with OSXWS 11 and without python

* Fri Feb 11 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx3b
- 2nd release on MacOS 12 for M1 Macs.
- added macos12, macos12-cint, cxx17, and macos12-cintdll patches.
- built with OSXWS 11 and python

* Thu Feb 10 2022 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-12hepx3a
- 1st release on MacOS 12 for M1 Macs.
- added macos12, macos12-cint, cxx17, and macos12-cintdll patches.
- built with OSXWS 11

* Fri Jan 24 2020 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-10.15hepx2a
- 1st release on MacOS X 10.15 for x86_64.
- added macosx10.15 patch.
- built with OSXWS 10.15

* Sat Dec 28 2019 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-10.14hepx2a
- 2nd release on MacOS X 10.14 for x86_64.
- added gcc9 and x11locaton patches:
  gcc9_stl_iterator.patch from 
  https://root-forum.cern.ch/uploads/default/original/3X/b/b/bb1a0d08782697f70f18cd22b99203c6247ff222.gz
- built with OSXWS 10.14

* Tue Dec 25 2018 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-10.14hepx1a
- 1st release on MacOS X 10.14 for x86_64.
- built with OSXWS 10.13

* Tue Apr 03 2018 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-10.13hepx1a
- 1st release on MacOS X 10.13 for x86_64.
- built with OSXWS 10.13

* Tue Dec 27 2016 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-10.12hepx1b
- 2nd release on MacOS X 10.12 for x86_64.
- built with OSXWS 10.12

* Mon Dec 19 2016 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.36-10.12hepx1a
- 1st release on MacOS X 10.12 for x86_64.
- built with OSXWS 10.11

* Fri Feb 12 2016 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.34-10.11hepx1a
- Package renamed to root5 to allow coexistnence with root6.
- 1st release on MacOS X 10.11 for x86_64.

* Tue Feb 09 2016 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.34-10.11hepx4a
- 1st release on MacOS X 10.11 for x86_64.

* Fri Apr 24 2015 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.30-10.10hepx4a
- 1st release on MacOS X 10.10 for x86_64.
- Patch release for Xcode 6.3.

* Wed Dec 24 2014 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.19-10.10hepx4a
- 1st release on MacOS X 10.10 for x86_64.
- Work around the problem due to the case-insensitive system with FTGlyph.h.

- built with gcc (macosx64)
* Fri Aug 08 2014 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.19-10.9hepx3b
- 2nd release on MacOS X 10.9 for x86_64.
- built with gcc (macosx64)

* Wed Aug 06 2014 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.19-10.9hepx3a
- 1st release on MacOS X 10.9 for x86_64.
- built with clang

* Mon Dec 16 2013 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.14-10.9hepx3a
- 1st release on MacOS X 10.9 for x86_64.

* Sun Dec 15 2013 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.12-10.9hepx3a
- 2nd release on MacOS X 10.9 for x86_64.
- Now automatically builds itself and installed into /opt/root/%{version}

* Sat Dec 07 2013 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.12-10.9hepx2a
- 1st release on MacOS X 10.9 for x86_64.
- Now pythia is searated as a independent package.
- Root hence requires pythia.

* Sun Nov 11 2012 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.03-10.7hepx1c
- 3rd release on MacOS X 10.7 for x86_64.
- Updated pythia from 6.415 to 6.424
- Fixed install_name of libPythia6.dylib so as to use @rpath

* Thu Nov 08 2012 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.03-10.7hepx1b
- 2nd release on MacOS X 10.7 for x86_64.
- Updated pythia from 6.415 to 6.422

* Wed Oct 31 2012 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.03-10.7hepx1a
- 1st release on MacOS X 10.7 for x86_64.

* Tue Oct 9 2012 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.02-10.7hepx1a
- 1st release on MacOS X 10.7 for x86_64.

* Tue Aug 21 2012 Keisuke Fujii <keisuke.fujii@kek.jp> 5.34.01-10.7hepx1a
- 1st release on MacOS X 10.7 for x86_64.

* Thu May 03 2012 Keisuke Fujii <keisuke.fujii@kek.jp> 5.32.00-10.7hepx1b
- 2nd release on MacOS X 10.7 for x86_64.
- rebuilt with gsl to support MathMore

* Wed May 02 2012 Keisuke Fujii <keisuke.fujii@kek.jp> 5.32.00-10.7hepx1a
- 1st release on MacOS X 10.7.
- now built for x86_64

* Fri Dec 23 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 5.32.00-10.6hepx1b
- 2nd release on MacOS X 10.7.
- rebuilt with gcc-32, g++-32, and gfortran-32 instead of clang suit.

* Thu Dec 22 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 5.32.00-10.6hepx1a
- 1st release on MacOS X 10.7.

* Tue Oct 11 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 5.30.02-10.6hepx1b
- 2nd release on MacOS X 10.6.
- rebuilt with MySQL-5.1.56

* Sat Sep 24 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 5.30.02-10.6hepx1a
- 1st release on MacOS X 10.6.

* Wed Jul 13 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 5.30.00-10.6hepx1a
- 1st release on MacOS X 10.6.

* Thu May 19 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 5.28.00d-10.6hepx1a
- 1st release on MacOS X 10.6.

* Wed Mar 2 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 5.28.00a-10.6hepx1a
- 1st release on MacOS X 10.6.

* Thu Jan 27 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 5.28.00-10.6hepx1b
- 2nd release on MacOS X 10.6.
- Added GDML support.

* Wed Jan 26 2011 Keisuke Fujii <keisuke.fujii@kek.jp> 5.28.00-10.6hepx1a
- 1st release on MacOS X 10.6.

* Sat Dec 04 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 5.27.06b-10.6hepx1a
- 1st release on MacOS X 10.6.

* Sat Dec 04 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 5.26.00d-10.6hepx1b
- 2nd release on MacOS X 10.6.
- Addd GDML support.

* Thu Sep 09 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 5.26.00d-10.6hepx1a
- 1st release on MacOS X 10.6.

* Sun May 09 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 5.26.00b-10.6hepx1a
- 1st release on MacOS X 10.6.

* Mon Mar 08 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 5.26.00a-10.6hepx1b
- 2nd release on MacOS X 10.6.
- Added map.so to Provides:

* Mon Mar 08 2010 Keisuke Fujii <keisuke.fujii@kek.jp> 5.26.00a-10.6hepx1a
- 1st release on MacOS X 10.6.

* Fri Mar 20 2009 Keisuke Fujii <keisuke.fujii@kek.jp> 5.22.00a-10.5hepx1a
- 1st release on MacOS X 10.5.

* Sat Mar 14 2009 Keisuke Fujii <keisuke.fujii@kek.jp> 5.22.00-10.5hepx1b
- 2nd release on MacOS X 10.5.
- Fixed install_name of libPythia6.so to use @rpath

* Thu Jan 15 2009 Keisuke Fujii <keisuke.fujii@kek.jp> 5.22.00-10.5hepx1a
- 1st release on MacOS X 10.5.

* Tue Sep 23 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 5.21.02-10.5hepx1a
- 1st release on MacOS X 10.5.

* Tue Aug 19 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 5.20.00-10.5hepx1b
- 2nd release on MacOS X 10.5.
- with fftw3 support.

* Thu Jul  3 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 5.20.00-10.5hepx1a
- 1st release on MacOS X 10.5 for Intel Macs.

* Mon Jun  9 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 5.19.04-10.5hepx1a
- 1st release on MacOS X 10.5 for Intel Macs.

* Thu Mar 27 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 5.19.02-10.5hepx1b
- 1st release on MacOS X 10.5 for PPC Macs.

* Wed Mar 26 2008 Keisuke Fujii <keisuke.fujii@kek.jp> 5.19.02-10.5hepx1a
- 1st release on MacOS X 10.5 for Intel Macs.
